/*
	specific implementation for accessing data in the web server
*/

import java.util.*;
import java.lang.*;
import java.net.*;
import java.io.*;

import com.ibm.xml.parser.*;
import org.w3c.dom.*;

public class httpModule implements dataAccess {

    private TXDocument doc;
    private Element root;

	public void open(String protocol, String location, String id, String pwd) {
	    
	    URL my_url = null;
	    InputStream inStream;
	    URLConnection url_conn;

		try {

			my_url = new URL(location);

		} catch (MalformedURLException e) {

			e.printStackTrace();
		}
		
		try {
	
			url_conn = my_url.openConnection();
			inStream = url_conn.getInputStream();

		} catch (Exception e) {

			e.printStackTrace();
			return;
		}
		
        // make the DOM tree, of which root is doc
            
        doc = new Parser(location).readStream(inStream);
        root = (Element)doc.getDocumentElement();
            
        try {
                
            // close the input stream
            
            inStream.close();
                
        } catch (IOException e) {
                
            e.printStackTrace();
        }
	}

	public void close() {
	    
	}

	public void update() {
	    
	}
	
	public String getValue(String name, String key) {

        if (root.hasChildNodes()) {

            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
           
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {
                    
                    NodeList keys = users.item(i).getParentNode().getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        String key_name = keys.item(j).getNodeName().toLowerCase();
                        
                        if (key_name.equals(key.toLowerCase()) && keys.item(j).getNodeType() == Node.ELEMENT_NODE) {
                            
                            return keys.item(j).getChildNodes().item(0).getNodeValue();
                        }
                    }
                }
            }
        }
                     
        return null;
	}

	public void setValue(String name, String key, String value) {

		try {

			throw new IllegalModificationException();

		} catch (Exception e) {

			e.printStackTrace();
		}
	}

	public void removeKey(String name, String key) {

		try {

			throw new IllegalModificationException();

		} catch (Exception e) {

			e.printStackTrace();
		}
	}

	public Enumeration getUsers() {

        Vector result = new Vector(20);

        if (root.hasChildNodes()) {
            
            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    result.addElement(users.item(i).getChildNodes().item(0).getNodeValue());
                }
            }
        }

        return result.elements();
    }

	public Enumeration getUserKeys(String name) {

        Vector result = new Vector(20);

        if (root.hasChildNodes()) {

            NodeList users = root.getElementsByTagName("name");
            
            for (int i = 0; i < users.getLength(); i++) {
           
                String user_name = null;
                
                if (users.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    user_name = users.item(i).getChildNodes().item(0).getNodeValue();
                }
                
                if (user_name != null && user_name.equals(name)) {
                    
                    NodeList keys = users.item(i).getParentNode().getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        if (keys.item(j).getNodeType() == Node.ELEMENT_NODE) {
                            
                            result.addElement(keys.item(j).getNodeName().toLowerCase());
                        }
                    }
                    
                    return result.elements();
                }
            }
        }
        
        return null;
	}

	public void addUser(String name) {

		try {

			throw new IllegalModificationException();

		} catch(Exception e) {

			e.printStackTrace();
		}
	}
	
	public void removeUser(String name) {

		try {

			throw new IllegalModificationException();

		} catch(Exception e) {

			e.printStackTrace();
		}
	}

}

